image: gcc:11

stages:
  - build
  - test
  - docker

compile:
  stage: build
  tags:
    - shared
  before_script:
    - apt-get update --yes
    - apt install --yes cmake
    - apt-get install --yes libgtest-dev
  script:
    - cmake -B ./build
    - make -C ./build
  artifacts:
    paths:
      - ./build/tests

test:
  stage: test
  needs: ["compile"]
  tags:
    - shared
  script:
    - ./build/tests --gtest_output=xml:report.xml
  artifacts:
    name: ${CI_JOB_NAME}-${CI_COMMIT_REF_NAME}-${CI_COMMIT_SHA}
    when: always
    reports:
      junit: report.xml

docker-build:
  stage: docker
  image: docker:20-dind
  services:
    - name: docker:20-dind
      alias: docker
      command: ["--tls=false"]
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
  tags:
    - shared
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE" -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME" .
    - docker push "$CI_REGISTRY_IMAGE"
